;-
#define SYNCIN	GPIO,1
#define ANAIN	GPIO,0
#define OUTPUT	GPIO,2
#define LEDOUT	GPIO,5
	list	p=12c508a
#include <p12c508a.inc>
	__CONFIG _CP_OFF & _WDT_ON & _IntRC_OSC & _MCLRE_OFF

;  -    5 (+2   )
LOPAUSE		MACRO A
	LOCAL	label1
	movlw	A
	movwf	temp
label1
	nop
	nop
	decfsz	temp,1
	goto	label1
	ENDM

;
;ALL_VAR		UDATA
temp		RES 1
temp2		RES 1
lastgpio		RES 1	;  
#define	ALLOWCHECK	mystate, 1
#define	POWERON	mystate, 0
mystate	RES 1	;
front	RES 1	; 

;	CODE	0x00
	movwf	OSCCAL
;    ,  10
;..  ,  64.    61/
;  OPTION_REG
	movlw	b'11000101'
	option
;  -
	movlw	b'00000011'
	tris	6
	movlw	b'00011100'
	movwf	GPIO
	bcf	POWERON
	bcf	ALLOWCHECK

maincycle:
	clrwdt
;   
	movf	GPIO,0
	movwf	temp2
	xorwf	lastgpio,0
	movwf	temp
	movf	temp2,0
	movwf	lastgpio
	btfss	temp,1
	goto	notfront
;,    .  
	clrf	TMR0
	bcf	ALLOWCHECK
;  500
	LOPAUSE	.100
;,    ,   - 
	btfsc	POWERON
	goto	poweron
; -   
	btfss	lastgpio,1
	goto	notpoweron
	incf	front,1
	btfss	front,2
	goto	notpoweron	
;   -   1/3 
	LOPAUSE	.250
	LOPAUSE	.250
	LOPAUSE	.250
	bsf	LEDOUT	; 
	clrf	front
poweron:
	bsf	ALLOWCHECK
	movlw	b'11100011'
	andwf	GPIO,1
notpoweron:
;  500
	LOPAUSE	.200
;  
	movlw	b'00011100'
	iorwf	GPIO,1
; - ,  
notfront:
	btfss	lastgpio,1	;  
	goto	notchecktimer
; 
;     ,   
;5   .    - 79
	movlw	.110
	subwf	TMR0,0
	btfss	STATUS,C
	goto	notcheck
; (  )
	btfss	ALLOWCHECK
	goto	notcheck
	bcf	ALLOWCHECK

	bcf	LEDOUT	; 

	btfsc	ANAIN	; - !!!
	goto	offpower
	bsf	POWERON
	bsf	LEDOUT
	goto	notcheck
offpower:
	bcf	POWERON
	bcf	LEDOUT
	clrf	front
notcheck
notchecktimer
	goto	maincycle

	END